<template>

	<div class="d-flex align-items-start justify-content-end">
        <div class="cg-empty-wrap" v-if="!message_users_.length">
            <div class="cg-empty-content-wrap text-center add-btm-mdm">
                <img src="/images/no-items.svg" alt="creativegoods" class="img-ﬂuid width-30">
                <h4 class="font1 grey f18 w500 pad-top-mdm pad-btm-xsml">You don't have any messages yet.</h4>

            </div>
        </div>

        <div class="message-thumb-panel">
            <h2 class="contact-heading-text">Contacts</h2>
            <a v-if="message_users_.length" v-for="(message_user, index) in message_users_" @click="fetchMyMessagesChangeUser(index, message_user.stranger_id)" v-bind:class="{ active: active_sender.id==message_user.stranger_id }" class="cg-message-thumb d-flex align-items-center justify-content-start">
                <div class="cg-message-nav-icon-wrap">
                    <img :src="message_user.stranger.user_profile.image_path" class="img-fluid cg-message-nav-icon" :alt="message_user.stranger.name">
                    <div v-if="message_user.unread" class="unread-message-dot"></div>
                </div>
                <h3>{{ message_user.stranger.short_user_name }}<br><span>{{ message_user.last_message_date }}</span></h3>
            </a>
        </div>
        <div class="mini-page d-flex align-items-center justify-content-end flex-column" v-if="message_users_.length">

            <div class="messenger-head-wrap d-flex align-items-center justify-content-start flex-column">
                <div class="messenger-thumb-icon-wrap d-flex align-items-center justify-content-center">
                    <div class="messenger-thumb-icon" v-bind:class="{ 'messenger-thumb-cg-bot-icon': active_sender.role=='admin' }"><img :src="active_sender.user_profile.image_path" class="img-fluid" :alt="active_sender.name"></div>
                </div>
                <a class="go-to-new d-flex align-items-center justify-content-center" href="#new-messege-here">
                    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" fill="none" stroke="#fff" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-arrow-down"><line x1="12" y1="5" x2="12" y2="19"></line><polyline points="19 12 12 19 5 12"></polyline></svg>
                </a>
                <h2 class="messenger-name-text">{{ active_sender.name }}</h2>
                <h5 class="messenger-date-text">Last Messaged on  {{ last_message_date }} </h5>
            </div>

            <div class="chat-bubbles-wrap" id="message_scroll">
                <div v-for="message in messages_.slice().reverse()" >
                    <span class="text-white badge text-danger" v-if="message.subject">{{ message.subject }}</span>
                    <div class="row d-flex justify-content-start" :id="'msg'+ message.id" v-if="message.is_received"><div class="out-chat"><div class="chat-arrow-left"></div><h4>{{ message.message }}</h4></div></div>
                    <div class="row d-flex justify-content-end"  :id="'msg'+ message.id" v-if="message.is_sent"><div class="in-chat"><div class="chat-arrow"></div><h4> {{ message.message }} </h4></div></div>
                </div>
            </div>

            <div class="message-type-bar d-flex align-items-center justify-content-center flex-column" v-if="message_users_.length && active_sender.role == 'author' || active_sender.role == 'user'">
                <textarea rows="2" cols="5" v-model="message_text" id="message-type" placeholder="Type message.."></textarea>
                <div class="messege-footer d-flex align-items-center justify-content-between">
                    <a class="message-send-btn" href="#" id="submit" @click.prevent="formSubmit">Send Message</a>
                    <div class="messege-extra-buttons d-flex align-items-center justify-content-center" v-if="message_users_.length">
<!--                        <ul class="d-flex"><li><a href="#" class="cg-msg-report-btn">Report</a></li><li><a href="">Block</a></li></ul>-->
                    </div>
                </div>
            </div>
        </div>
        </div>
</template>
<script>
    import MessagePagination from '../components/MessagePagination'
    import Preloader from '../components/Preloader.vue'
    export default {
        data(){
            return{
                scrollHeight: 0,
                interval: null,
                messages_:[],
                message_users_:[],
                active_sender:[],
                last_message_date:'',
                message_text:'',
                user_index:0,
                pagination: {
                    'current_page': 1
                },
            }

        },
        components:{
            MessagePagination,
        },
        methods: {
            fetchMyMessages(receiver_id) {
                axios.get('/get_my_messages?page=' + this.pagination.current_page +'&receiver_id=' + receiver_id)
                    .then(response => {
                        let messages_array = response.data.data;
                        this.active_sender= response.data.active_sender;
                        this.last_message_date=response.data.last_message_date;
                        this.messages_ = messages_array

                        this.loadJs('/js/messagescroll.js', function() {
                            //Stuff to do after someScript has loaded
                        });
                    })
                    .catch(error => {
                        console.log(error.response.data);
                    });
            },
            fetchMyMessagesChangeUser(index, receiver_id) {
                this.message_users_[index].unread=false;
                this.user_index = index;
                this.messages_=[];
                axios.get('/get_my_messages?page=' + this.pagination.current_page +'&receiver_id=' + receiver_id)
                    .then(response => {
                        let messages_array = response.data.data;
                        this.active_sender= response.data.active_sender;
                        this.last_message_date=response.data.last_message_date;
                        this.messages_ = messages_array
                        this.loadJs('/js/messagescroll.js', function() {
                            //Stuff to do after someScript has loaded
                        });

                        // this.pagination = response.data.pagination;
                    })
                    .catch(error => {
                        console.log(error.response.data);
                    });
            },
            fetchMessageUsers() {

                  this.preLoad();
                axios.get('/get_my_message_users?page=' + this.pagination.current_page)
                    .then(response => {
                        this.message_users_ = response.data.data.data;
                        this.pagination = response.data.pagination;
                        this.active_sender= response.data.active_sender;
                       this.fetchMyMessages(this.active_sender.id)
                    })
                    .catch(error => {
                        console.log(error.response.data);
                    });
            },
            formSubmit(){

                if(this.message_text)
                {

                    document.getElementById('submit').disabled=true;
                    let currentObj = this;

                    const config = {
                        headers: {
                            'content-type':'application/json',
                            'Accept':'application/json'
                        }
                    }
                    let formData = new FormData();

                    formData.append('receiver_id',  this.active_sender.id);
                    formData.append('message_text',  this.message_text);

                   this.preLoad();
                    axios.post('/sent_message', formData, config).then((response)=>{

                        document.getElementById('submit').disabled=false;
                       if(response.data.status == 'success')
                        {
                            this.message_text='';
                         this.fetchMyMessagesChangeUser(this.user_index, this.active_sender.id)
                        }
                        else
                        {
                          console.log( response.data.message)

                        }
                    })
                }


                },

            preLoad: function() {
                // just open
                const close = this.$preloaders.open({
                    container: ".cg-pop-panel-body",
                    component:Preloader,
                    "overlayStyle": {
                        "backgroundColor": "#fff",
                        "opacity": 1,
                    }
                });

                // and close. That's it.
                setTimeout(close, 2000);
            },
            loadJs(url, callback) {
                jQuery.ajax({
                    url: url,
                    dataType: 'script',
                    success: callback,
                    async: true
                });
            },
        },

        mounted(){
           // this.fetchMyMessages();
            this.fetchMessageUsers()
            this.preLoad();

        }
    }

</script>
